package org.nakedobjects.nos.store.file;

import org.apache.log4j.Logger;
import org.nakedobjects.noa.persist.NakedObjectPersistor;
import org.nakedobjects.noa.reflect.NakedObjectReflector;
import org.nakedobjects.nof.core.persist.TimeBasedOidGenerator;
import org.nakedobjects.nof.core.system.ObjectLoaderInstaller;
import org.nakedobjects.nof.core.system.ObjectPersistorInstaller;
import org.nakedobjects.nof.core.util.NakedObjectConfiguration;
import org.nakedobjects.nof.persist.DefaultPersistAlgorithm;
import org.nakedobjects.nof.persist.objectstore.ObjectStorePersistor;


public class XmlPersistorInstaller implements ObjectPersistorInstaller {
    private static final Logger LOG = Logger.getLogger(XmlPersistorInstaller.class);
    private XmlObjectStore objectStore;

    public NakedObjectPersistor createObjectPersistor(final NakedObjectConfiguration configuration) {
        LOG.info("installing " + this.getClass().getName());

        if (objectStore == null) {
            objectStore = new XmlObjectStore();
            objectStore.setClock(new DefaultClock());
        }
        
        DefaultPersistAlgorithm persistAlgorithm = new DefaultPersistAlgorithm();
        ObjectStorePersistor persistor = new ObjectStorePersistor();
        persistor.setObjectStore(objectStore);
        persistor.setPersistAlgorithm(persistAlgorithm);
        persistor.setCheckObjectsForDirtyFlag(true);
        persistor.setOidGenerator(new TimeBasedOidGenerator());
        return persistor;
    }
    
    public String getName() {
        return "xml";
    }

    public ObjectLoaderInstaller getPreferredObjectLoaderInstaller() {
        return null;
    }

    public void setUpReflector(NakedObjectReflector reflector) {}
}
// Copyright (c) Naked Objects Group Ltd.
